#!groovy

node {

  stage ('checkout') {
    checkout scm
  }

  stage ('build domain model') {
    sh './gradlew --no-daemon --console=plain clean build'
  }

  stage ('publish') {

    def props = readProperties file: 'gradle.properties'
    def target_repository = null;
    println("Props: ${props}");
    def release_files = findFiles(glob: '**/casp_alerts_domain_model-*.*.*.jar')
    println("Release Files: ${release_files}");
    if ( release_files.size() == 1 ) {
      // println("Release file : ${release_files[0].name}");
      if ( release_files[0].name.contains('SNAPSHOT') ) {
          target_repository='semweb-snapshot';
      }
      else {
          target_repository='semweb-release';
      }
    }

    if ( target_repository != null ) {
      println("Publish ${release_files[0].path} with version ${props.appVersion} to ${target_repository}");
      // See https://github.com/jenkinsci/nexus-artifact-uploader-plugin/pull/13 for an example of manually specifying a pom.xml
      nexusArtifactUploader(
        nexusVersion: 'nexus3',
        protocol: 'https',
        nexusUrl: 'nexus.semweb.co',
        groupId: 'com.semweb.casp',
        version: props.appVersion,
        repository: target_repository,
        credentialsId: 'semweb-nexus',
        artifacts: [
          [artifactId: 'casp_alerts_domain_model',
           classifier: '',
           file: release_files[0].path,
           type: 'jar']
        ]
      )
    }
  }
}

